Index: /trunk/sources/HeuristicLab.Permutation/3.3/RandomPermutationCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Permutation/3.3/RandomPermutationCreator.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Permutation/3.3/RandomPermutationCreator.cs	(revision 2834)
@@ -51,5 +51,5 @@
     }
 
-    public override IExecutionSequence Apply() {
+    public override IOperation Apply() {
       PermutationParameter.ActualValue = new Permutation(LengthParameter.ActualValue.Value, RandomParameter.ActualValue);
       return base.Apply();
Index: /trunk/sources/HeuristicLab.Random/3.3/RandomCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Random/3.3/RandomCreator.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Random/3.3/RandomCreator.cs	(revision 2834)
@@ -59,5 +59,5 @@
     }
 
-    public override IExecutionSequence Apply() {
+    public override IOperation Apply() {
       if (SetSeedRandomlyParameter.ActualValue == null) SetSeedRandomlyParameter.ActualValue = new BoolData(true);
       bool setSeedRandomly = SetSeedRandomlyParameter.ActualValue.Value;
Index: /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/HeuristicLab.Routing.TSP.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/HeuristicLab.Routing.TSP.Views-3.3.csproj	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/HeuristicLab.Routing.TSP.Views-3.3.csproj	(revision 2834)
@@ -86,4 +86,12 @@
       <Name>HeuristicLab.MainForm-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization.Views\3.3\HeuristicLab.Optimization.Views-3.3.csproj">
+      <Project>{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}</Project>
+      <Name>HeuristicLab.Optimization.Views-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
Index: /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/HeuristicLabRoutingTSPViewsPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/HeuristicLabRoutingTSPViewsPlugin.cs.frame	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/HeuristicLabRoutingTSPViewsPlugin.cs.frame	(revision 2834)
@@ -33,4 +33,6 @@
   [PluginDependency("HeuristicLab.MainForm", "3.2")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.2")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization.Views", "3.3")]
   [PluginDependency("HeuristicLab.Routing.TSP", "3.3")]
   public class HeuristicLabRoutingTSPViewsPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.Designer.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.Designer.cs	(revision 2834)
@@ -50,7 +50,7 @@
       this.SuspendLayout();
       // 
-      // valueParameterCollectionView
+      // parameterCollectionView
       // 
-      this.valueParameterCollectionView.Size = new System.Drawing.Size(490, 205);
+      this.parameterCollectionView.Size = new System.Drawing.Size(490, 205);
       // 
       // nameTextBox
@@ -85,5 +85,5 @@
       this.Name = "TSPView";
       this.Controls.SetChildIndex(this.importButton, 0);
-      this.Controls.SetChildIndex(this.valueParameterCollectionView, 0);
+      this.Controls.SetChildIndex(this.parameterCollectionView, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
       this.Controls.SetChildIndex(this.descriptionLabel, 0);
Index: /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.cs	(revision 2834)
@@ -24,4 +24,5 @@
 using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
+using HeuristicLab.Optimization.Views;
 
 namespace HeuristicLab.Routing.TSP.Views {
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj	(revision 2834)
@@ -109,4 +109,8 @@
       <Name>HeuristicLab.Operators-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj">
+      <Project>{14AB8D24-25BC-400C-A846-4627AA945192}</Project>
+      <Name>HeuristicLab.Optimization-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
       <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame	(revision 2834)
@@ -32,4 +32,5 @@
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Permutation", "3.3")]
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs	(revision 2834)
@@ -22,4 +22,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Permutation;
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs	(revision 2834)
@@ -51,5 +51,5 @@
     }
 
-    public override IExecutionSequence Apply() {
+    public override IOperation Apply() {
       DoubleMatrixData distanceMatrix = DistanceMatrixParameter.ActualValue;
       Permutation.Permutation permutation = PermutationParameter.ActualValue;
Index: /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs	(revision 2834)
@@ -50,5 +50,5 @@
     }
 
-    public override IExecutionSequence Apply() {
+    public override IOperation Apply() {
       DoubleMatrixData coordinates = CoordinatesParameter.ActualValue;
       Permutation.Permutation permutation = PermutationParameter.ActualValue;
Index: /trunk/sources/HeuristicLab.SGA/3.3/SGAOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.SGA/3.3/SGAOperator.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.SGA/3.3/SGAOperator.cs	(revision 2834)
@@ -193,5 +193,5 @@
     }
 
-    public override IExecutionSequence Apply() {
+    public override IOperation Apply() {
       int populationSize = CurrentScope.SubScopes.Count;
       // dynamically set the number of parents which are selected for reproduction
Index: /trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Selection/3.3/Reducer.cs	(revision 2834)
@@ -46,5 +46,5 @@
     }
 
-    public sealed override IExecutionSequence Apply() {
+    public sealed override IOperation Apply() {
       List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
       List<IScope> reduced = Reduce(scopes);
Index: /trunk/sources/HeuristicLab.Selection/3.3/Selector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Selection/3.3/Selector.cs	(revision 2834)
@@ -59,5 +59,5 @@
     }
 
-    public sealed override IExecutionSequence Apply() {
+    public sealed override IOperation Apply() {
       List<IScope> scopes = new List<IScope>(CurrentScope.SubScopes);
       IScope[] selected = Select(scopes);
Index: /trunk/sources/HeuristicLab.SequentialEngine/3.3/SequentialEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.SequentialEngine/3.3/SequentialEngine.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.SequentialEngine/3.3/SequentialEngine.cs	(revision 2834)
@@ -21,6 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -57,25 +55,25 @@
     protected override void ProcessNextOperator() {
       currentOperator = null;
-      IExecutionSequence next = ExecutionStack.Pop();
-      ExecutionContextCollection coll = next as ExecutionContextCollection;
+      IOperation next = ExecutionStack.Pop();
+      OperationCollection coll = next as OperationCollection;
       while (coll != null) {
         for (int i = coll.Count - 1; i >= 0; i--)
           ExecutionStack.Push(coll[i]);
         next = ExecutionStack.Count > 0 ? ExecutionStack.Pop() : null;
-        coll = next as ExecutionContextCollection;
+        coll = next as OperationCollection;
       }
-      ExecutionContext context = next as ExecutionContext;
-      if (context != null) {
+      IAtomicOperation operation = next as IAtomicOperation;
+      if (operation != null) {
         try {
-          currentOperator = context.Operator;
-          ExecutionStack.Push(context.Operator.Execute(context));
+          currentOperator = operation.Operator;
+          ExecutionStack.Push(operation.Operator.Execute((IExecutionContext)operation));
           currentOperator = null;
         }
         catch (Exception ex) {
-          ExecutionStack.Push(context);
+          ExecutionStack.Push(operation);
           Stop();
           OnExceptionOccurred(ex);
         }
-        if (context.Operator.Breakpoint)
+        if (operation.Operator.Breakpoint)
           Stop();
       }
